//+------------------------------------------------------------------+
//|                       originally Lawgirl's Trend Display by Gspe |
//|                               this version by mrtools            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#property indicator_chart_window

//
//
//
//
//

extern bool		ShowCurrentPairOnly   = false;               //	Dispaly only chart Pair
extern string	PairsToTrade          = "AUDCAD,AUDCHF,AUDNZD,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURNZD,EURJPY,EURUSD,GBPCHF,GBPJPY,GBPUSD,NZDUSD,NZDJPY,USDCAD,USDCHF,USDJPY";
extern string	PeriodsToTrade        = "H4,D1,W1,MN";    // Time Frames to display are user defined

extern string	pdi                   ="----Pair display inputs----";
extern int		FontSize              = 10;
extern color	FontColour            = Yellow;
extern string	Font_Font             = "Lucida Sans Unicode";
extern double	DisplayStarts_X       = 5;	                  // we positioning the object from the top right corner of window
extern double	DisplayStarts_Y       = 15;
extern int     corner                = 1;
extern bool		IndicatorInIchiWindow = false;	           
extern string	Ichimoku_WindowName   = "Ichimoku2";			  

extern int     Tenkan                = 9;
extern int     Kijun                 = 26;
extern int     Senkou                = 52;
extern int     ChinkouShift          = -26;
extern int     bar                   = 0;

extern int	   symbolCodeSUP         = 233;
extern int	   symbolCodeSDN         = 234;
extern int		symbolCodeNoSignal    = 232;
extern color	colorCodeSUP          = Blue;
extern color   colorCodeSDN          = Red;
extern color	colorCodeNoSignal     = Gold;

extern int     alertWhen             = 2;
extern bool    alertImmediate        = true;
extern bool    alertsOn              = true;
extern bool    alertsMessage         = true;
extern bool    alertsSound           = false;
extern bool    alertsEmail           = false;

//
//
//
//
//

double   trendStates[][2];
string	TradePair[];			   //Array to hold the pairs traded by the user
string	TradePeriod[];			   //Array to hold the periods traded by the user
int		TradePeriodTF[];	   	//Array to hold the periods traded by the user
int		TradeTrendSymbol[][6];	//Array to hold the pairs trend symbol
color 	TradeTrendColor[][6];	//Array to hold the pairs trend color
bool  	AlertSent[];

//
//
//
//
//

int		NoOfPairs;				// Holds the number of pairs passed by the user via the inputs screen
int		NoOfPeriods;			// Holds the number of periods passed by the user via the inputs screen
int		OldBars;
int      WindowNo = 0;

string   objPrefix;	         // all objects drawn by this indicator will be prefixed with this
string   buff_str;	         // all objects drawn by this indicator will be prefixed with this
string	trend;

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{

	int i, j;
	objPrefix = WindowExpertName();
	
	if(IndicatorInIchiWindow)
	{
		WindowNo = WindowFind(Ichimoku_WindowName);
		if(WindowNo < 0)
		{
			Alert("Ichimoku_WindowName is Wrong");
			return(0);
		}
		DisplayStarts_X = 5;
		DisplayStarts_Y = 5;
	}
   
   //
   //
   //
   //
   //
   
	if(!ShowCurrentPairOnly)
	{
	
		NoOfPairs = StringFindCount(PairsToTrade,",")+1;
		ArrayResize(TradePair, NoOfPairs);
		string AddChar = StringSubstr(Symbol(),6,4);
		StrPairToStringArray(PairsToTrade, TradePair, AddChar);
	}
	else
	{
		
		NoOfPairs = 1;
		ArrayResize(TradePair, NoOfPairs);
		TradePair[0] = Symbol();
	}

   //
   //
   //
   //
   //
   	
	  ArrayResize(trendStates,NoOfPairs);
	  for (int k=0; k<NoOfPairs; k++) trendStates[k][0]=0;

   //
   //
   //
   //
   //
   	  
	NoOfPeriods = StringFindCount(PeriodsToTrade, ",")+1;
	ArrayResize(TradePeriod, NoOfPeriods);
	ArrayResize(TradePeriodTF, NoOfPeriods);
	StrToStringArray(PeriodsToTrade, TradePeriod);
	
	for(j=0; j<NoOfPeriods; j++)
	{
		TradePeriodTF[j] = StrToTF(TradePeriod[j]);	
	}
	
   //	
   //
   //
   //
   //
   
	ArrayResize(TradeTrendSymbol, NoOfPairs);
	ArrayInitialize(TradeTrendSymbol, symbolCodeNoSignal);
	ArrayResize(TradeTrendColor, NoOfPairs);
	ArrayInitialize(TradeTrendColor, colorCodeNoSignal);		
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() {	Comment(""); RemoveObjects(objPrefix);	return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   GetPairTrends(TradeTrendSymbol, TradeTrendColor);
   PrintPairTrends();

return(0);
}

//
//-------------------------------------------------------------------+
//                                                                   |
//-------------------------------------------------------------------+
//
//

void RemoveObjects(string Pref)
{   
	int i;
	string objname = "";

	for (i = ObjectsTotal(); i >= 0; i--)
	{
		objname = ObjectName(i);
		if (StringFind(objname, Pref, 0) > -1) ObjectDelete(objname);
	}
	return(0);
} 

//+------------------------------------------------------------------+
// StringFindCount                                                   |
//+------------------------------------------------------------------+
//
//

int StringFindCount(string str, string str2)
{
  int c = 0;
  for (int i=0; i<StringLen(str); i++)
    if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
return(c);
} 

//+------------------------------------------------------------------+
// StrPairToStringArray                                              |
//+------------------------------------------------------------------+
//
//

void StrPairToStringArray(string str, string &a[], string p_suffix, string delim=",")
{
	int z1=-1, z2=0;
	for (int i=0; i<ArraySize(a); i++)
	{
		z2 = StringFind(str,delim,z1+1);
		a[i] = StringSubstr(str,z1+1,z2-z1-1) + p_suffix;
		if (z2 >= StringLen(str)-1)   break;
		z1 = z2;
	}
return(0);
} 

//+------------------------------------------------------------------+
// StrToStringArray                                                  |
//+------------------------------------------------------------------+
//
//

void StrToStringArray(string str, string &a[], string delim=",")
{
	int z1=-1, z2=0;
	for (int i=0; i<ArraySize(a); i++)
	{
		z2 = StringFind(str,delim,z1+1);
		a[i] = StringSubstr(str,z1+1,z2-z1-1);
		if (z2 >= StringLen(str)-1)   break;
		z1 = z2;
	}
return(0);
} 

//+------------------------------------------------------------------+
// StrToTF(string str)                                               |
//+------------------------------------------------------------------+
// 
// 

int StrToTF(string str)
{
  str = StringUpper(str);
  str = StringTrimLeft(str);
  str = StringTrimRight(str);
  
  if (str == "M1")   return(1);
  if (str == "M5")   return(5);
  if (str == "M15")  return(15);
  if (str == "M30")  return(30);
  if (str == "H1")   return(60);
  if (str == "H4")   return(240);
  if (str == "D1")   return(1440);
  if (str == "W1")   return(10080);
  if (str == "MN")   return(43200);
return(0);
}  

//+------------------------------------------------------------------+
// StringUpper(string str)                                           |
//+------------------------------------------------------------------+
// 
// 

string StringUpper(string str)
{
  string outstr = "";
  string lower  = "abcdefghijklmnopqrstuvwxyz";
  string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  
  //
  //
  //
  //
  //
  
  for(int i=0; i<StringLen(str); i++)  
  {
    int t1 = StringFind(lower,StringSubstr(str,i,1),0);
    if (t1 >=0)  
      outstr = outstr + StringSubstr(upper,t1,1);
    else
      outstr = outstr + StringSubstr(str,i,1);
  }
return(outstr);
}  

//+------------------------------------------------------------------+
//| GetPairTrends                                                    |
//+------------------------------------------------------------------+
//
//

void GetPairTrends(int &trend_symbol[][], color &trend_color[][])
{
	int i, j;
	
	//
	//
	//
	//
	//
	
	for (i=0; i<NoOfPairs; i++)
	{
	   int signalsDn = 0;
	   int signalsUp = 0;
	   
	   //
	   //
	   //
	   //
	   //
	   
		for(j=0; j<NoOfPeriods; j++)
		{
			trend_symbol[i][j] = symbolCodeNoSignal;
			trend_color[i][j]  = colorCodeNoSignal;
			
			//
			//
			//
			//
			//
			
			double Var1   = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,0,bar);
         double Var11  = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,0,bar+1);
         double Var2   = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,1,bar);
         double Var22  = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,1,bar+1);
         double Var3   = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,2,bar);
         double Var4   = iCustom(TradePair[i],TradePeriodTF[j],"Ichimoku2",Tenkan,Kijun,Senkou,ChinkouShift,4,bar);
         double Var5   =  iClose(TradePair[i],TradePeriodTF[j],                                               bar);  
         
         //
         //
         //
         //
         //
         
			if (Var5 > Var3)
			{
			  if (Var5 > Var1 && Var5 > Var2 && Var1 > Var2)
			  {
				 trend_symbol[i][j] = symbolCodeSUP;
				 trend_color[i][j]  = colorCodeSUP;
				 signalsUp++;
				} 
				
			} 
			
			//
			//
			//
			//
			//
			
			if (Var5 < Var3)
			{
			  if (Var5 < Var1 && Var5 < Var2 && Var1 < Var2)
			  {
				 trend_symbol[i][j] = symbolCodeSDN;
				 trend_color[i][j]  = colorCodeSDN;
				 signalsDn++;
				} 
				
				
			} 
		} 
		
		//
		//
		//
		//
		//
		
		if (signalsDn>=alertWhen || signalsUp>=alertWhen)
		{
   		if (!alertImmediate && trendStates[i][0] == 0)
   		{
   		    if (signalsDn >= alertWhen) { trendStates[i][0] = -1; trendStates[i][1] = -1; }
   		    if (signalsUp >= alertWhen) { trendStates[i][0] =  1; trendStates[i][1] =  1; }
   		}
   		else
   		{
   		    if (signalsDn >= alertWhen) trendStates[i][1] = -1;
   		    if (signalsUp >= alertWhen) trendStates[i][1] =  1;
   		    if (trendStates[i][0]!=trendStates[i][1])
   		    {
   		       trendStates[i][0]=trendStates[i][1];
                if (trendStates[i][1]==1)
   		            doAlert(TradePair[i]+" "+alertWhen+" or more signals alligned up");
                else doAlert(TradePair[i]+" "+alertWhen+" or more signals alligned down");  		          
   		    }
   		}
      }   		
	} 
	return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   string message;

   if (!alertsOn) return;   
       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"Ichimoku trend display ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Ichimoku trend display "),message);
          if (alertsSound)   PlaySound("alert2.wav");
}

//+------------------------------------------------------------------+
//| PrintPairTrends                                                  |
//+------------------------------------------------------------------+
//
//

void PrintPairTrends()
{
	RemoveObjects(objPrefix);
	
	int i, j;
	
	//
	//
	//
	//
	//
	
	for (i=0; i<NoOfPairs; i++)
	{
		buff_str = StringConcatenate(objPrefix, TradePair[i]);
		ObjectDelete(buff_str);
		ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
		   ObjectSet(buff_str,OBJPROP_CORNER,corner);
		   ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + FontSize*(NoOfPeriods*2));
		   ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y + (i+1)*(FontSize+FontSize/2));
  	  ObjectSetText(buff_str,TradePair[i],FontSize-2,Font_Font,FontColour);
	}
	
	//
	//
	//
	//
	//
	
	for (j=0; j<NoOfPeriods; j++)
	{
		buff_str = StringConcatenate(objPrefix, TradePeriod[j]);
		ObjectDelete(buff_str);
		ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
		   ObjectSet(buff_str,OBJPROP_CORNER,corner);
		   ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + (NoOfPeriods-1-j)*(FontSize*2));
		   ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y);
	  ObjectSetText(buff_str,TradePeriod[j],FontSize-2,Font_Font,FontColour);      
	}
	
	//
	//
	//
	//
	//
	
	for (i=0; i<NoOfPairs; i++)
	{
		for (j=0; j<NoOfPeriods; j++)
		{
			buff_str = StringConcatenate(objPrefix, TradePair[i], TradePeriod[j]);
			ObjectDelete(buff_str);
			ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
 			   ObjectSet(buff_str,OBJPROP_CORNER,corner);
		   	ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + (NoOfPeriods-1-j)*(FontSize*2));
			   ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y + (i+1)*(FontSize+FontSize/2));
		  ObjectSetText(buff_str,CharToStr(TradeTrendSymbol[i][j]),FontSize,"Wingdings",TradeTrendColor[i][j]);
		}
  }
return(0);
}


//There are 6 different conditions you can watch for

//0 = Close above/below cloud" ;  
//1 = Close above/below Tenkan" ;
//2 = Close above/below Tenkan&Kijun" ;
//3 = Close above/below Tenkan&Kijun&Cloud" ;
//4 = Close above/below Tenkan&Kijun &&Cloud && Tenkan is above/below Kijun ";
//5 = Close above/below Tenkan&Kijun && Tenkan is above/below Kijun ";
//6 = Close above/below Kijun";



